// pivpcsc.h: useful PC/SC constructs
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The PIV Middleware Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#ifndef __pivpcsc_h__
#define __pivpcsc_h__
#ifdef __cplusplus
extern "C" {
#endif

#ifndef __APPLE__
#include <winscard.h>
#else
#include <PCSC/wintypes.h>
#include <PCSC/winscard.h>
#endif

#include "pivdefs.h"
#define PCSC_MAX_BUFFERSIZE     260

#define APDU_CLA        0
#define APDU_INS        1
#define APDU_P1         2
#define APDU_P2         3
#define APDU_P3         4
#define APDU_DATA       5


/* Local transport structure */
typedef struct _PCSCTransmitBuffer {
  PIV_UChar8 buffer[PCSC_MAX_BUFFERSIZE];
  PIV_ULong32 bufferSize;
  PIV_UChar8 apduResponse[PCSC_MAX_BUFFERSIZE];
  PIV_ULong32 apduResponseSize;
  LPSCARD_IO_REQUEST ioType;
} PCSCTransmitBuffer, *PCSCLPTransmitBuffer;

                                
PIV_RV CheckPCSCStatus(SCARDHANDLE hCard, PDWORD pcscStatus, PDWORD pcscProtocol);

#ifdef __cplusplus
}
#endif
#endif
