// pivtlp224
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The PIV Middleware Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#ifndef __pivtlp224_h__
#define __pivtlp224_h__
#ifdef __cplusplus
extern "C" {
#endif


#include "pivdefs.h"
#include "pivpcsc.h"

SCARDCONTEXT SCardGetHContext ();

DYNAMIC_LIB PIV_RV SCardHookListReaders(LPSTR mszReaders, LPDWORD pcchReaders);
DYNAMIC_LIB PIV_RV SCardHookConnect(LPCSTR readerName, DWORD dwShareMode, DWORD dwPreferredProtocols, LPSCARDHANDLE phCard, LPDWORD pdwActiveProtocol);
DYNAMIC_LIB PIV_RV SCardHookReconnect(SCARDHANDLE hCard, DWORD dwShareMode, DWORD dwPreferredProtocols, DWORD dwInitialization,LPDWORD pdwActiveProtocol );
DYNAMIC_LIB PIV_RV SCardHookDisconnect(SCARDHANDLE hCard);
DYNAMIC_LIB PIV_RV SCardHookStatus ( SCARDHANDLE hCard, LPDWORD pdwState );
DYNAMIC_LIB PIV_RV SCardHookEstablish (void);
DYNAMIC_LIB PIV_RV SCardHookRelease (void);
DYNAMIC_LIB PIV_RV SCardHookBeginTransaction (SCARDHANDLE hCard);
DYNAMIC_LIB PIV_RV SCardHookEndTransaction (SCARDHANDLE hCard);
DYNAMIC_LIB PIV_RV SCardHookExchangeAPDU ( SCARDHANDLE hCard, PCSCLPTransmitBuffer transmitBuffer );

PIV_RV CheckPCSCStatus(SCARDHANDLE hCard, PDWORD pcscStatus, PDWORD pcscProtocol);

DYNAMIC_LIB char* Stringify_Error(PIV_RV errorCode);

#ifdef __cplusplus
}
#endif
#endif
