// Manager
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#include <Manager.h>


long Manager :: open_log_file ( const char * filename )
{
  return 1 ;
}


long Manager :: flush_log_file ( void )
{
  return 1 ;
}


long Manager :: close_log_file ( void )
{
  return 1 ;
}


long Manager :: log_file_comment ( const char * comment )
{
  return 1 ;
}


void Manager :: set_verbosity ( int v )
{
  the_verbosity = v ;
}


int Manager :: get_verbosity ( void )
{
  return the_verbosity ;
}

bool Manager :: store_persistent_state ( FILE * , unsigned short & )
  { return true ; } ; 

bool Manager :: load_persistent_state ( FILE * , unsigned short & )
  { return true ; } ; 

// An APDU is a persistent Octet_String
// that knows how to interface with APDU_Packet
void APDU::store_into_APDU_packet ( APDU_Packet & packet ) const
  {
    packet . set_APDU_length ( length ( ) ) ;
    Octet_String::cpy ( packet . APDU ( ) , 
                        static_cast < Memory::size_t > 
                            ( packet . max_APDU_size ( ) )  , 
                        * this ,
                        length ( ) );
  } ;

APDU::APDU ( const APDU_Packet & packet )
  : Octet_String ( packet . APDU ( ) , 
                    static_cast < Memory::size_t > 
                        ( packet . get_APDU_length ( ) ) )
  { } ;

APDU::APDU ( const Octet_String & data_block )
  : Octet_String ( data_block )
  { } ;
