// Card Service Interface
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#if !defined(__CARD_SERVICE_INTERFACE_H_INCLUDED__)
#define __CARD_SERVICE_INTERFACE_H_INCLUDED__

#include <Octet_String.h>


class Card_Service_Interface
{
public:
  virtual unsigned char
  get_card_content_state ( void ) = 0 ;

  virtual bool
  set_card_content_state ( unsigned char new_state ) = 0 ;

  virtual unsigned char
  get_card_state ( void ) = 0 ;

  virtual bool
  lock_card ( void ) = 0 ;

  virtual bool
  terminate_card ( void ) = 0 ;

  virtual bool
  set_ATR_hist_bytes ( Octet_String & new_hist_bytes ) = 0 ;

  // virtual SC_Service & get_secure_channel ( void ) = 0 ;

  // virtual CVM_Service & get_cvm ( void ) = 0 ;
} ;

#endif // __CARD_SERVICE_INTERFACE_H_INCLUDED__