// Key Generation
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#if !defined(__KEY_GENERATION_H_INCLUDED__)
#define __KEY_GENERATION_H_INCLUDED__

#if defined(_MSC_VER )
  #if defined(KEY_GENERATION_EXPORTS)
    #define KEY_GENERATION_DLL _declspec(dllexport)
  #else //  defined ( KEY_GENERATION_EXPORTS )
    #define KEY_GENERATION_DLL _declspec(dllimport)
  #endif  // defined ( KEY_GENERATION_EXPORTS )
#else
   #define KEY_GENERATION_DLL
#endif

#if defined(_WIN32) && defined(__cplusplus)
extern "C" {
#endif  /* defined(_WIN32) && defined(__cplusplus) */

void KEY_GENERATION_DLL RSA_Key_Generation ( 
    byte *modulus, long *mlen,
    byte *private_key, long *plen,
    byte *exponent, long *elen) ;

void KEY_GENERATION_DLL RSA_Key_Operation ( 
    byte *modulus, long mlen,
    byte *exponent, long elen,
    byte *input, long ilen,
    byte *output, long *olen) ;

#if defined(_WIN32) && defined(__cplusplus)
} /* extern "C" */
#endif  /* defined(_WIN32) && defined(__cplusplus) */

#endif  // !defined ( __KEY_GENERATION_H_INCLUDED__)
