// SocketIO -- Socket Setup and Teardown support
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#if !defined(__SOCKETIO_H_INCLUDED__)
#define __SOCKETIO_H_INCLUDED__

#if defined(__cplusplus)
extern "C" {
#endif

#include <Winsock2.h>

extern long SocketIO_initialize ( void ) ;

extern long SocketIO_initialize_listener ( int port , SOCKET * listening_socket , SOCKET * connection_socket ) ;

extern long SocketIO_initialize_talker ( const char * host , int port , SOCKET * talking_socket ) ;

extern long SocketIO_finalize ( void ) ;

extern long SocketIO_finalize_listener ( SOCKET * listening_socket , SOCKET * connection_socket ) ;

extern long SocketIO_finalize_talker ( SOCKET * talking_socket ) ;

#if defined(__cplusplus)
  }
#endif

#endif   // !defined(__SOCKETIO_H_INCLUDED__)
