// pivvscr_configDlg.h : header file
//

#pragma once

// PIV Virtual Smart Card Reader registry keys
#define PIVVSCR_PARAMETERS_REGKEY		_T("SYSTEM\\CurrentControlSet\\Services\\PIV Virtual Smart Card Reader\\Parameters")

// PIV Virtual Smart Card Reader registry values
#define PIVVSCR_HOSTNAME_REGVALUE		_T("Host")
#define PIVVSCR_PORT_REGVALUE			_T("Port")
#define PIVVSCR_POLLINTERVAL_REGVALUE	_T("Poll Interval")
#define PIVVSCR_AUTOINSERT_REGVALUE		_T("Auto Insert")

#define PIVVSCR_CONFIG_PORT_MINVALUE			0	// reserved but valid
#define PIVVSCR_CONFIG_PORT_MAXVALUE			65535
#define PIVVSCR_CONFIG_POLLINTERVAL_MINVALUE	1		// 1 ms
#define PIVVSCR_CONFIG_POLLINTERVAL_MAXVALUE	3600000	// 1 hour

// Cpivvscr_configDlg dialog
class Cpivvscr_configDlg : public CDialog
{
// Construction
public:
	Cpivvscr_configDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_PIVVSCR_CONFIG_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	CString m_cstrHostName;
	DWORD m_dwPortNumber;
	DWORD m_dwPollInterval;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedApplyNow();
	afx_msg void OnBnClickedClose();
	BOOL m_bAutoInsert;
};