#include "stdafx.h"
#include "Registry.h"

long CreateRegistryKey(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName)
{
	HKEY hNewKey;
	DWORD dwDisposition;
	long lRetVal;

	lRetVal = ::RegCreateKeyEx(hPredefinedKey, lpszRegKeyName, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hNewKey, &dwDisposition);
	RegCloseKey(hNewKey);

	return lRetVal;
}

//	get Generic
long GetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, DWORD dwValueType, BYTE *lpData, LPDWORD lpcbData)
{
	HKEY hKey;
	long lRetVal;

	lRetVal = ::RegOpenKeyEx(hPredefinedKey, lpszRegKeyName, 0, KEY_QUERY_VALUE, &hKey);

	if (lRetVal == ERROR_SUCCESS) {

		lRetVal = ::RegQueryValueEx(hKey, lpszValueName, NULL, NULL, lpData, lpcbData);
		RegCloseKey(hKey);
	}

	return lRetVal;
}

// get size of
long GetRegistryValueSize(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, LPDWORD dwSize)
{
	return GetRegistryValue(hPredefinedKey, lpszRegKeyName, lpszValueName, 0, NULL, dwSize);
}

//	get REG_SZ
long GetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, CString *pCString, DWORD dwSize)
{
	BYTE *data;
	long lRetValue;
	
	data = new BYTE[dwSize];

	// get the string
	lRetValue = GetRegistryValue(hPredefinedKey, lpszRegKeyName, lpszValueName, 0, data, &dwSize);
	memcpy(pCString->GetBuffer(), data, dwSize);
	pCString->ReleaseBuffer();

	delete[] data;

	return lRetValue;
}

//	get REG_DWORD
long GetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, LPDWORD lpdwData)
{
	BYTE *data = new BYTE[sizeof(DWORD)];
	DWORD dwSize = sizeof(DWORD);

	long lRetValue = GetRegistryValue(hPredefinedKey, lpszRegKeyName, lpszValueName, 0, data, &dwSize);
	memcpy(lpdwData, data, sizeof(DWORD));

	delete[] data;

	return lRetValue;
}

//	set Generic
long SetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, DWORD dwValueType, const BYTE *lpData, DWORD cbData)
{
	HKEY hKey;
	long lRetVal;

	lRetVal = ::RegOpenKeyEx(hPredefinedKey, lpszRegKeyName, 0, KEY_SET_VALUE, &hKey);
	lRetVal = ::RegSetValueEx(hKey, lpszValueName, 0, dwValueType, lpData, cbData);
	::RegCloseKey(hKey);
	return lRetVal;
}

//	set REG_SZ
long SetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, CString *pCStrValue)
{
	return SetRegistryValue(hPredefinedKey, lpszRegKeyName, lpszValueName, REG_SZ, (BYTE*)pCStrValue->GetBuffer(pCStrValue->GetLength()), pCStrValue->GetLength()+1);
}

//	set REG_DWORD
long SetRegistryValue(HKEY hPredefinedKey, LPCTSTR lpszRegKeyName, LPCTSTR lpszValueName, const LPDWORD lpdwValue)
{
	return SetRegistryValue(hPredefinedKey, lpszRegKeyName, lpszValueName, REG_DWORD, (const BYTE*)lpdwValue, sizeof(DWORD));
}
